//
// Generated file, do not edit! Created by nedtool 4.6 from message.msg.
//

#ifndef _MESSAGE_M_H_
#define _MESSAGE_M_H_

#include <omnetpp.h>

// nedtool version check
#define MSGC_VERSION 0x0406
#if (MSGC_VERSION!=OMNETPP_VERSION)
#    error Version mismatch! Probably this file was generated by an earlier version of nedtool: 'make clean' should help.
#endif



/**
 * Class generated from <tt>message.msg:19</tt> by nedtool.
 * <pre>
 * //
 * // TODO generated message class
 * //
 * packet Message
 * {
 *     int NodeID;
 *     int PacketID;
 *     int TopicID;
 *     string type;
 *     string topic = "NULL";
 *     string data;
 *     int SourceID;
 *     int DestinationID;
 * 
 * 
 *     //zigbee
 *     int Tx_power;
 * }
 * </pre>
 */
class Message : public ::cPacket
{
  protected:
    int NodeID_var;
    int PacketID_var;
    int TopicID_var;
    opp_string type_var;
    opp_string topic_var;
    opp_string data_var;
    int SourceID_var;
    int DestinationID_var;
    int Tx_power_var;

  private:
    void copy(const Message& other);

  protected:
    // protected and unimplemented operator==(), to prevent accidental usage
    bool operator==(const Message&);

  public:
    Message(const char *name=NULL, int kind=0);
    Message(const Message& other);
    virtual ~Message();
    Message& operator=(const Message& other);
    virtual Message *dup() const {return new Message(*this);}
    virtual void parsimPack(cCommBuffer *b);
    virtual void parsimUnpack(cCommBuffer *b);

    // field getter/setter methods
    virtual int getNodeID() const;
    virtual void setNodeID(int NodeID);
    virtual int getPacketID() const;
    virtual void setPacketID(int PacketID);
    virtual int getTopicID() const;
    virtual void setTopicID(int TopicID);
    virtual const char * getType() const;
    virtual void setType(const char * type);
    virtual const char * getTopic() const;
    virtual void setTopic(const char * topic);
    virtual const char * getData() const;
    virtual void setData(const char * data);
    virtual int getSourceID() const;
    virtual void setSourceID(int SourceID);
    virtual int getDestinationID() const;
    virtual void setDestinationID(int DestinationID);
    virtual int getTx_power() const;
    virtual void setTx_power(int Tx_power);
};

inline void doPacking(cCommBuffer *b, Message& obj) {obj.parsimPack(b);}
inline void doUnpacking(cCommBuffer *b, Message& obj) {obj.parsimUnpack(b);}


#endif // ifndef _MESSAGE_M_H_

